function MW = transfo_haar_2D(M)
n = length(M);
MW = M;
for j = log2(n):-1:1
    %Vertical
    A = MW(1:2^j,1:2^j);
    Coarse = ( A(1:2:size(A,1),:) + A(2:2:size(A,1),:) )/sqrt(2);
    Detail = ( A(1:2:size(A,1),:) - A(2:2:size(A,1),:) )/sqrt(2);
    
    %Horizontal
    A = [Coarse ;Detail];
           % A COMPLETER % 
end